#include <stdlib.h>
#include <stddef.h>

unsigned char SPWR_Get_Packet(void);
void SPWR_Send_Packet(unsigned char n_bytes);
void IRQ_SPWR_handler(void);
void Init(void);

unsigned char buf[128];
#pragma interrupt 6 IRQ_SPWR_handler

void main(void)
{
    SWCON_Bits.LINKEN=1;
    SWCON_Bits.WDTIMEOUT=10;

    IOPORT1=SWCAPSTAT_Bits.CAPRX;
    IOPORT1=SWCAPSTAT_Bits.CAPTX;

    SWDATAT_Bits.TRANSDATA=0xff;

    Init();
    while (1)
    {}
}

void Init(void)
{
    _di_();
    WSR=0x01;           // Hwindow 1
    IOC3=0x0C;          // IOC3=0000 1100 (dout,sout on out)

    WSR=0x0F;           // Hwindow 15
    INT_MASK|=0x40;     // serial int enable)
    WSR=0x00;           // Hwindow 0

    SWINTMASK=0x0020;   // GOT_EOP interrupt
    SWCON=0x0A07;       // SpaceWire module ON, WDTIMEOUT=10, LINKSTART, LINCAUTO, LINKEN

    while (!(SWSTAT&0x0008))  // wait for connection
    {}
    _ei_();
}

void IRQ_SPWR_handler(void)
{
    unsigned char n_bytes;
    //if (SWINTMASK_Bits.EOPINT&&SWSTAT_Bits.EOPREC)  // if Got_EOP
    if (SWINTMASK&SWSTAT&0x0020)                     // if Got_EOP
    {
        SWSTAT&=~(0x0020);                       // clear flag
        n_bytes=SPWR_Get_Packet();
        SPWR_Send_Packet(n_bytes);
    }
}

unsigned char SPWR_Get_Packet(void)
{
    unsigned char cnt=0;
    while (!SWDATAR_Bits.EOP_EEP)
    {
        buf[cnt++]=SWDATAR_Bits.RECDATA;
    }
    while (!(SWDATAR&0x0100))
    {
        buf[cnt++]=SWDATAR&0x00FF;
    }

    return cnt;
}

void SPWR_Send_Packet(unsigned char n_bytes)
{
    unsigned char i;
    for (i=0;i<n_bytes;i++)
    {
        SWDATAT=buf[i];
    }
    SWDATAT=0x100;      // EOP
}

